<?php
/**************************************************
  Coppermine 1.5.x Plugin - auto_release
  *************************************************
  Copyright (c) 2014 eenemeenemuu
  *************************************************
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  ********************************************
  $HeadURL: https://svn.code.sf.net/p/coppermine/code/branches/cpg1.5.x/plugins/quick_tag/codebase.php $
  $Revision: 8735 $
  $LastChangedBy: eenemeenemuu $
  $Date: 2014-08-14 12:35:34 +0200 (Do, 14 Aug 2014) $
  **************************************************/

if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');

// Config: enter the user_ids which should be allowed to use the release feature
function get_privileged_users() {
    $privileged_users = array(1);
    return $privileged_users;
}

$thisplugin->add_action('plugin_install','auto_release_install');
$thisplugin->add_action('plugin_uninstall','auto_release_uninstall');
$thisplugin->add_action('page_start','auto_release_start');


function auto_release_install() {
    global $CONFIG;
    if (cpg_db_query("INSERT INTO {$CONFIG['TABLE_CONFIG']} (name,value) VALUES ('plugin_auto_release_last_check','".time()."')")) {
        return TRUE;
    } else {
        return FALSE;
    }
}


function auto_release_uninstall() {
    global $CONFIG;
    if (cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name LIKE 'plugin_auto_release_%'")) {
        return TRUE;
    } else {
        return FALSE;
    }
}


function auto_release_start() {
    global $CONFIG;
    $time = time();
    if ($CONFIG['plugin_auto_release_last_check'] < $time - 300) { // don't check on every page load - reduce cpu load
        cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value = '$time' WHERE name = 'plugin_auto_release_last_check'");
        $privileged_users = implode(",", get_privileged_users());
        $picturelist = cpg_db_query("SELECT pid, keywords FROM {$CONFIG['TABLE_PICTURES']} WHERE approved = 'NO' AND owner_id IN ($privileged_users) AND keywords LIKE '____-__-__'");
        while ($row = mysql_fetch_assoc($picturelist)) {
            $release_date = explode("-", $row['keywords']);
            $release_timestamp = mktime(0, 0, 0, $release_date[1], $release_date[2], $release_date[0]);
            if ($release_timestamp < $time) {
                cpg_db_query("UPDATE {$CONFIG['TABLE_PICTURES']} SET approved = 'YES', ctime = '$release_timestamp', keywords = '' WHERE pid = {$row['pid']}");
            }
        }
    }
}

?>